#include "xscommon.h"

/*
  FILE and fopen(), fclose(), etc.
  adds a lot of code
  so avoid to use it
  use open() instead
*/

WORD FileExists(char *fname, DWORD fsize) {
int fl;
  fl = open(fname, O_RDONLY | O_BINARY);
  if (fl != -1) {
    if (fsize) {
      lseek(fl, 0, SEEK_END);
      fsize = (((DWORD) tell(fl)) == fsize) ? 1 : 0;
    } else {
      fsize = 1;
    }
    close(fl);
  } else {
    fsize = 0;
  }
  return(fsize);
}

/*
  compare two strings
  c - NOT null terminated string, max 12 characters
  s - ASCIIZ null terminated string
*/
int MatchItem(char *c, char *s) {
int i, r;
  r = 1;
  for (i = 0; i < 12; i++) {
    /* not equal chars - strings not matched */
    if (*c != *s) {
      r = 0;
      break;
    }
    /* string ends earlier */
    if (!*c) { break; }
    /* go to next chars */
    c++;
    s++;
  }
  /* if 12 chars exceeded
     and there are still
     chars left in s */
  if (*s) {
    r = 0;
  }
  return(r);
}

/*
  atoi() adds a lot of code
  (mostly due to large character table for the isdigit() function)
  so avoid to use it
*/
WORD StrToInt(char *s) {
WORD r;
  r = 0;
  if (s) {
    for (; *s; s++) {
      if ((*s >= '0') && (*s <= '9')) {
        r *= 10;
        r += (*s - '0');
      } else {
        break;
      }
    }
  }
  return(r);
}

void IntToStr(char *s, WORD v) {
WORD l;
WORD d;
  if (s) {
    l = v;
    d = 0;
    do {
      d++;
      l /= 10;
    } while (l);
    l = v;
    s[d] = 0;
    while (d--) {
      s[d] = '0' + (l % 10);
      l /= 10;
    }
  }
}

/*
  sprintf() adds a lot of code
  (not only the function itself but the error strings for floating types, etc.)
  so avoid to use that function
  arguments:
  buf - output buffer
  len - length in characters of output buffer (including last zero tail char)
  ... - strings to merge, last one MUST be NULL (used as arguments terminator)
*/
void StrMerge(char *buf, WORD len, ...) {
va_list args;
char *s;
  /* sanity checks */
  if (buf && len) {
    va_start(args, len);
    /* reserved 1 char for tail null */
    len--;
    /* merge all strings */
    do {
      s = va_arg(args, char *);
      if (s) {
        while (*s && len) {
          *buf = *s;
          buf++;
          s++;
          len--;
        }
      }
    } while (s && len);
    va_end(args);
    /* tail null */
    *buf = 0;
  }
}
