#ifndef __XSMODMAP_H
#define __XSMODMAP_H

#include <io.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <string.h>

#include "modsetup.h"
#include "xscommon.h"

#define EP_WORLDMAP_LEVELS 20
#define EP_WORLDMAP_FANIMS 3

#pragma pack(push, 1)
typedef struct {
  SHORT nTile;
  SHORT X;
  SHORT Y;
} TileInfo;

typedef struct {
  SHORT X;
  SHORT Y;
  TileInfo Back[2];
  TileInfo Name;
} NameInfo;

typedef struct {
  TileInfo Frame[4];
} FireAnim;

typedef struct {
  SHORT    nFire;
  TileInfo Fire[3];
} FireInfo;

typedef struct {
  BYTE     Shift[EP_WORLDMAP_LEVELS];
  NameInfo Title[EP_WORLDMAP_LEVELS];
  FireAnim FAnim[EP_WORLDMAP_FANIMS];
  FireInfo Fires[EP_WORLDMAP_LEVELS];
} WorldMap;
#pragma pack(pop)

void WorldMapDumper(int fl, int flags);

#endif
